Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/p4zsink.F90	(revision 2643)
@@ -21,48 +21,41 @@
    PUBLIC   p4z_sink         ! called in p4zbio.F90
    PUBLIC   p4z_sink_init    ! called in trcsms_pisces.F90
+   PUBLIC   p4z_sink_alloc
 
    !! * Shared module variables
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &   !:
-     wsbio3, wsbio4,      &    !: POC and GOC sinking speeds
-     wscal                     !: Calcite and BSi sinking speeds
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: wsbio3   !: POC sinking speed 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: wsbio4   !: GOC sinking speed
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: wscal    !: Calcite and BSi sinking speeds
 
    !! * Module variables
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &   !:
-     sinking, sinking2,   &    !: POC sinking fluxes (different meanings depending on the parameterization
-     sinkcal, sinksil,    &    !: CaCO3 and BSi sinking fluxes
-     sinkfer                   !: Small BFe sinking flux
-
-   INTEGER  :: &
-      iksed  = 10              !
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: sinking, sinking2  !: POC sinking fluxes 
+   !                                                                 !  (different meanings depending on the parameterization)
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: sinkcal, sinksil   !: CaCO3 and BSi sinking fluxes
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: sinkfer            !: Small BFe sinking fluxes
+#if ! defined key_kriest
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: sinkfer2           !: Big iron sinking fluxes
+#endif
+
+   INTEGER  :: iksed  = 10
 
 #if  defined key_kriest
-   REAL(wp)          ::       &   
-      xkr_sfact    = 250.  ,  &   !: Sinking factor
-      xkr_stick    = 0.2   ,  &   !: Stickiness
-      xkr_nnano    = 2.337 ,  &   !: Nbr of cell in nano size class
-      xkr_ndiat    = 3.718 ,  &   !: Nbr of cell in diatoms size class
-      xkr_nmeso    = 7.147 ,  &   !: Nbr of cell in mesozoo  size class
-      xkr_naggr    = 9.877        !: Nbr of cell in aggregates  size class
-
-   REAL(wp)          ::       &   
-      xkr_frac
-
-   REAL(wp), PUBLIC ::        &
-      xkr_dnano            ,  &   !: Size of particles in nano pool
-      xkr_ddiat            ,  &   !: Size of particles in diatoms pool
-      xkr_dmeso            ,  &   !: Size of particles in mesozoo pool
-      xkr_daggr            ,  &   !: Size of particles in aggregates pool
-      xkr_wsbio_min        ,  &   !: min vertical particle speed
-      xkr_wsbio_max               !: max vertical particle speed
-
-   REAL(wp), PUBLIC, DIMENSION(jpk) ::   &   !:
-      xnumm                       !:     maximum number of particles in aggregates
-
-#endif
-
-#if ! defined key_kriest
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &   !:
-     sinkfer2                  !: Big Fe sinking flux
-#endif 
+   REAL(wp) ::  xkr_sfact    = 250.     !: Sinking factor
+   REAL(wp) ::  xkr_stick    = 0.2      !: Stickiness
+   REAL(wp) ::  xkr_nnano    = 2.337    !: Nbr of cell in nano size class
+   REAL(wp) ::  xkr_ndiat    = 3.718    !: Nbr of cell in diatoms size class
+   REAL(wp) ::  xkr_nmeso    = 7.147    !: Nbr of cell in mesozoo  size class
+   REAL(wp) ::  xkr_naggr    = 9.877    !: Nbr of cell in aggregates  size class
+
+   REAL(wp) ::  xkr_frac 
+
+   REAL(wp), PUBLIC ::  xkr_dnano       !: Size of particles in nano pool
+   REAL(wp), PUBLIC ::  xkr_ddiat       !: Size of particles in diatoms pool
+   REAL(wp), PUBLIC ::  xkr_dmeso       !: Size of particles in mesozoo pool
+   REAL(wp), PUBLIC ::  xkr_daggr       !: Size of particles in aggregates pool
+   REAL(wp), PUBLIC ::  xkr_wsbio_min   !: min vertical particle speed
+   REAL(wp), PUBLIC ::  xkr_wsbio_max   !: max vertical particle speed
+
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:) :: xnumm  !:  maximum number of particles in aggregates
+#endif
 
    !!* Substitution
@@ -76,4 +69,5 @@
 CONTAINS
 
+
 #if defined key_kriest
 
@@ -87,5 +81,6 @@
       !! ** Method  : - ???
       !!---------------------------------------------------------------------
-
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: znum3d    => wrk_3d_2
       INTEGER, INTENT(in) :: kt, jnt
       INTEGER  :: ji, jj, jk
@@ -99,9 +94,11 @@
       INTEGER  :: ik1
 #endif
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   znum3d
       CHARACTER (len=25) :: charout
 
       !!---------------------------------------------------------------------
 
+      IF( wrk_in_use(3, 2 ) ) THEN
+         CALL ctl_stop('p4z_sink: requested workspace arrays unavailable')  ;  RETURN
+      END IF
       !     Initialisation of variables used to compute Sinking Speed
       !     ---------------------------------------------------------
@@ -311,4 +308,6 @@
        ENDIF
 
+      IF( wrk_not_released(3, 2 ) ) CALL ctl_stop('p4z_sink: failed to release workspace arrays')
+      !
    END SUBROUTINE p4z_sink
 
@@ -611,4 +610,7 @@
       !!      transport term, i.e.  div(u*tra).
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: ztraz => wrk_3d_2, zakz => wrk_3d_3, zwsink2 => wrk_3d_4
+      !
       INTEGER , INTENT(in   )                         ::   jp_tra    ! tracer index index      
       REAL(wp), INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   pwsink    ! sinking speed
@@ -617,8 +619,10 @@
       INTEGER  ::   ji, jj, jk, jn
       REAL(wp) ::   zigma,zew,zign, zflx, zstep
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  ztraz, zakz
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  zwsink2
-      !!---------------------------------------------------------------------
-
+      !!---------------------------------------------------------------------
+
+      IF(  wrk_in_use(3, 2,3,4 ) ) THEN
+         CALL ctl_stop('p4z_sink2: requested workspace arrays unavailable')
+         RETURN
+      END IF
 
       zstep = rfact2 / 2.
@@ -704,7 +708,27 @@
       psinkflx(:,:,:)   = 2. * psinkflx(:,:,:)
 
+      IF( wrk_not_released(3, 2,3,4 ) ) CALL ctl_stop('p4z_sink2: failed to release workspace arrays')
       !
    END SUBROUTINE p4z_sink2
 
+   INTEGER FUNCTION p4z_sink_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE p4z_sink_alloc  ***
+      !!----------------------------------------------------------------------
+
+      ALLOCATE( wsbio3(jpi,jpj,jpk), wsbio4(jpi,jpj,jpk), wscal(jpi,jpj,jpk),  &
+        &       sinking(jpi,jpj,jpk), sinking2(jpi,jpj,jpk)                 ,  &                
+        &       sinkcal(jpi,jpj,jpk), sinksil(jpi,jpj,jpk)                  ,  &                
+#if defined key_kriest
+        &       xnumm(jpk)                                                  ,  &                
+#else
+        &       sinkfer2(jpi,jpj,jpk)                                       ,  &                
+#endif
+
+        &       sinkfer(jpi,jpj,jpk), STAT=p4z_sink_alloc )                
+
+      IF( p4z_sink_alloc /= 0 ) CALL ctl_warn('p4z_sink_alloc : failed to allocate arrays.')
+
+   END FUNCTION p4z_sink_alloc
 #else
    !!======================================================================
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/sms_pisces.F90	(revision 2643)
@@ -38,42 +38,44 @@
    !!* Damping 
    LOGICAL  ::   ln_pisdmp         !: relaxation or not of nutrients to a mean value
-                                   !: when initialize from a restart file 
    LOGICAL  ::   ln_pisclo         !: Restoring or not of nutrients to initial value
                                    !: on close seas
 
    !!*  Biological fluxes for light
-   INTEGER , DIMENSION(jpi,jpj)     ::   neln       !: number of T-levels + 1 in the euphotic layer
-   REAL(wp), DIMENSION(jpi,jpj)     ::   heup       !: euphotic layer depth
+   INTEGER , ALLOCATABLE, SAVE,   DIMENSION(:,:)  ::  neln       !: number of T-levels + 1 in the euphotic layer
+   REAL(wp), ALLOCATABLE, SAVE,   DIMENSION(:,:)  ::  heup       !: euphotic layer depth
 
    !!*  Biological fluxes for primary production
-   REAL(wp), DIMENSION(jpi,jpj)     ::   xksi       !: ???
-   REAL(wp), DIMENSION(jpi,jpj)     ::   xksimax    !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xnanono3   !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xdiatno3   !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xnanonh4   !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xdiatnh4   !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xlimphy    !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xlimdia    !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   concdfe    !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   concnfe    !: ???
+   REAL(wp), ALLOCATABLE, SAVE,   DIMENSION(:,:)  ::   xksi       !: ???
+   REAL(wp), ALLOCATABLE, SAVE,   DIMENSION(:,:)  ::   xksimax    !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xnanono3   !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xdiatno3   !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xnanonh4   !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xdiatnh4   !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimphy    !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   xlimdia    !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   concdfe    !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:)  ::   concnfe    !: ???
 
    !!*  SMS for the organic matter
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xfracal    !: ??
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   nitrfac    !: ??
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xlimbac    !: ??
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   xdiss      !: ??
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   xfracal    !: ??
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   nitrfac    !: ??
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   xlimbac    !: ??
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   xdiss      !: ??
 #if defined key_diatrc
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   prodcal    !: Calcite production
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   grazing    !: Total zooplankton grazing
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   prodcal    !: Calcite production
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   grazing    !: Total zooplankton grazing
 #endif
 
    !!* Variable for chemistry of the CO2 cycle
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   akb3       !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ak13       !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ak23       !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   aksp       !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   akw3       !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   borat      !: ???
-   REAL(wp), DIMENSION(jpi,jpj,jpk) ::   hi         !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   akb3       !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ak13       !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   ak23       !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   aksp       !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   akw3       !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   borat      !: ???
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   hi         !: ???
+
+   !!* Array used to indicate negative tracer values
+   REAL(wp), ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   xnegtr     !: ???
 
 #if defined key_kriest
@@ -84,4 +86,47 @@
    REAL(wp) ::   xkr_mass_min, xkr_mass_max         !: ???
 #endif
+
+CONTAINS
+
+   INTEGER FUNCTION sms_pisces_alloc()
+      !!----------------------------------------------------------------------
+      !!        *** ROUTINE sms_pisces_alloc ***
+      !!----------------------------------------------------------------------
+      USE lib_mpp , ONLY: ctl_warn
+      INTEGER :: ierr(5)        ! Local variables
+      !!----------------------------------------------------------------------
+
+      ierr(:) = 0
+
+      !*  Biological fluxes for light
+      ALLOCATE( neln(jpi,jpj), heup(jpi,jpj),                           STAT=ierr(1) )
+
+      !*  Biological fluxes for primary production
+      ALLOCATE( xksimax(jpi,jpj)     , xksi(jpi,jpj)        ,               &
+         &      xnanono3(jpi,jpj,jpk), xdiatno3(jpi,jpj,jpk),               &
+         &      xnanonh4(jpi,jpj,jpk), xdiatnh4(jpi,jpj,jpk),               &
+         &      xlimphy (jpi,jpj,jpk), xlimdia (jpi,jpj,jpk),               &
+         &      concdfe (jpi,jpj,jpk), concnfe (jpi,jpj,jpk),           STAT=ierr(2) ) 
+
+      !*  SMS for the organic matter
+      ALLOCATE( xfracal (jpi,jpj,jpk), nitrfac (jpi,jpj,jpk),               &
+#if defined key_diatrc
+         &      prodcal(jpi,jpj,jpk) , grazing(jpi,jpj,jpk) ,               &
+#endif 
+         &      xlimbac (jpi,jpj,jpk), xdiss(jpi,jpj,jpk)   ,           STAT=ierr(3) )  
+
+      !* Variable for chemistry of the CO2 cycle
+      ALLOCATE( akb3(jpi,jpj,jpk), ak13(jpi,jpj,jpk) ,                      &
+         &      ak23(jpi,jpj,jpk), aksp(jpi,jpj,jpk) ,                      &
+         &      akw3(jpi,jpj,jpk), borat(jpi,jpj,jpk), hi(jpi,jpj,jpk), STAT=ierr(4) )
+
+      !* Array used to indicate negative tracer values  
+      ALLOCATE( xnegtr(jpi,jpj,jpk),                                    STAT=ierr(5) )
+
+      sms_pisces_alloc = MAXVAL( ierr )
+
+      IF( sms_pisces_alloc /= 0 ) CALL ctl_warn('sms_pisces_alloc : failed to allocate arrays.') 
+
+   END FUNCTION sms_pisces_alloc
 
 #else
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/trcini_pisces.F90	(revision 2643)
@@ -21,5 +21,11 @@
    USE oce_trc         ! ocean variables
    USE p4zche 
-   USE lib_mpp
+   USE p4zche          ! 
+   USE p4zsink         ! 
+   USE p4zopt          ! 
+   USE p4zprod         !
+   USE p4zrem          ! 
+   USE p4zsed          ! 
+   USE p4zflx          ! 
 
    IMPLICIT NONE
@@ -29,12 +35,11 @@
 
    !! * Module variables
-   REAL(wp) :: &
-      sco2   =  2.312e-3         , &
-      alka0  =  2.423e-3         , &
-      oxyg0  =  177.6e-6         , &
-      po4    =  2.174e-6         , &
-      bioma0 =  1.000e-8         , &
-      silic1 =  91.65e-6         , &
-      no3    =  31.04e-6 * 7.6
+   REAL(wp) :: sco2   =  2.312e-3 
+   REAL(wp) :: alka0  =  2.423e-3
+   REAL(wp) :: oxyg0  =  177.6e-6 
+   REAL(wp) :: po4    =  2.174e-6 
+   REAL(wp) :: bioma0 =  1.000e-8  
+   REAL(wp) :: silic1 =  91.65e-6  
+   REAL(wp) :: no3    =  31.04e-6 * 7.6
 
 #  include "top_substitute.h90"
@@ -55,11 +60,10 @@
 
 
-      !  Control consitency
-      CALL trc_ctl_pisces
-
-
       IF(lwp) WRITE(numout,*)
       IF(lwp) WRITE(numout,*) ' trc_ini_pisces :   PISCES biochemical model initialisation'
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+
+
+      CALL pisces_alloc()                          ! Allocate PISCES arrays
 
       !                                            ! Time-step
@@ -129,25 +133,38 @@
       !
    END SUBROUTINE trc_ini_pisces
- 
-   SUBROUTINE trc_ctl_pisces
+
+   SUBROUTINE pisces_alloc
       !!----------------------------------------------------------------------
-      !!                     ***  ROUTINE trc_ctl_pisces  ***
+      !!                     ***  ROUTINE pisces_alloc  ***
       !!
-      !! ** Purpose :   control the cpp options, namelist and files 
+      !! ** Purpose :   Allocate all the dynamic arrays of PISCES 
       !!----------------------------------------------------------------------
+      USE p4zint , ONLY : p4z_int_alloc      
+      USE p4zsink, ONLY : p4z_sink_alloc      
+      USE p4zopt , ONLY : p4z_opt_alloc           
+      USE p4zprod, ONLY : p4z_prod_alloc         
+      USE p4zrem , ONLY : p4z_rem_alloc           
+      USE p4zsed , ONLY : p4z_sed_alloc          
+      USE p4zflx , ONLY : p4z_flx_alloc
+      !
+      INTEGER :: ierr
+      !!----------------------------------------------------------------------
+      !
+      ierr =         sms_pisces_alloc()          ! Start of PISCES-related alloc routines...
+      ierr = ierr +     p4z_che_alloc()
+      ierr = ierr +     p4z_int_alloc()
+      ierr = ierr +    p4z_sink_alloc()
+      ierr = ierr +     p4z_opt_alloc()
+      ierr = ierr +    p4z_prod_alloc()
+      ierr = ierr +     p4z_rem_alloc()
+      ierr = ierr +     p4z_sed_alloc()
+      ierr = ierr +     p4z_flx_alloc()
+      !
+      IF( lk_mpp    )   CALL mpp_sum( ierr )
+      IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'pisces_alloc : unable to allocate PISCES arrays' )
 
-      IF(lwp) WRITE(numout,*)
-      IF(lwp) WRITE(numout,*) ' use PISCES biological model '
+      !
+   END SUBROUTINE pisces_alloc
 
-   ! Check number of tracers
-   ! -----------------------
-#if  defined key_kriest
-      IF( jp_pisces /= 23) CALL ctl_stop( ' PISCES must have 23 passive tracers. Change jp_pisces in par_pisces.F90' )
-#else
-      IF( jp_pisces /= 24) CALL ctl_stop( ' PISCES must have 24 passive tracers. Change jp_pisces in par_pisces.F90' )
-#endif
-
-   END SUBROUTINE trc_ctl_pisces
-  
 #else
    !!----------------------------------------------------------------------
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/trcnam_pisces.F90	(revision 2643)
@@ -19,5 +19,4 @@
    USE trc             ! TOP variables
    USE sms_pisces      ! sms trends
-   USE in_out_manager  ! I/O manager
 
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/trcrst_pisces.F90	(revision 2643)
@@ -18,9 +18,6 @@
    USE trcsms_pisces          ! pisces sms trends
    USE sms_pisces          ! pisces sms variables
-   USE in_out_manager  ! I/O manager
    USE iom
    USE trcdta
-   USE lib_mpp
-   USE lib_fortran
 
    IMPLICIT NONE
@@ -108,12 +105,10 @@
       !! ** purpose  : Relaxation of some tracers
       !!----------------------------------------------------------------------
-      INTEGER  :: ji, jj, jk
-      REAL(wp) ::  &
-         alkmean = 2426. ,  & ! mean value of alkalinity ( Glodap ; for Goyet 2391. )
-         po4mean = 2.165 ,  & ! mean value of phosphates
-         no3mean = 30.90 ,  & ! mean value of nitrate
-         silmean = 91.51      ! mean value of silicate
-
-      REAL(wp) :: zarea, zvol, zalksum, zpo4sum, zno3sum, zsilsum
+      REAL(wp) ::  alkmean = 2426.     ! mean value of alkalinity ( Glodap ; for Goyet 2391. )
+      REAL(wp) ::  po4mean = 2.165     ! mean value of phosphates
+      REAL(wp) ::  no3mean = 30.90     ! mean value of nitrate
+      REAL(wp) ::  silmean = 91.51     ! mean value of silicate
+
+      REAL(wp) :: zarea, zalksum, zpo4sum, zno3sum, zsilsum
 
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/PISCES/trcsms_pisces.F90	(revision 2643)
@@ -16,6 +16,4 @@
    USE trc
    USE sms_pisces
-   USE lbclnk
-   USE lib_mpp
    
    USE p4zint          ! 
@@ -65,12 +63,18 @@
       !!              - ...
       !!---------------------------------------------------------------------
+      USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
+      USE wrk_nemo, ONLY: ztrpis => wrk_3d_1   ! used for pisces sms trends
+      !
       INTEGER, INTENT( in ) ::   kt      ! ocean time-step index      
       !!
       INTEGER ::   jnt, jn
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrpis   ! used for pisces sms trends
       CHARACTER (len=25) :: charout
       !!---------------------------------------------------------------------
 
       IF( kt == nit000 )   CALL trc_sms_pisces_init    ! Initialization (first time-step only)
+
+      IF( wrk_in_use(3,1) )  THEN
+        CALL ctl_stop('trc_sms_pisces : requested workspace array unavailable.')  ;  RETURN
+      ENDIF
 
       IF( ndayflxtr /= nday_year ) THEN      ! New days
@@ -111,4 +115,5 @@
             CALL trd_mod_trc( ztrpis, jn, jptra_trd_sms, kt )   ! save trends
           END DO
+          DEALLOCATE( ztrpis )
       END IF
 
@@ -122,4 +127,6 @@
          !
       ENDIF
+
+      IF( wrk_not_released(3,1) ) CALL ctl_stop('trc_sms_pisces : failed to release workspace array.') 
 
    END SUBROUTINE trc_sms_pisces
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/SED/sedini.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/SED/sedini.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/SED/sedini.F90	(revision 2643)
@@ -17,5 +17,4 @@
    USE sedarr
    USE iom
-   USE in_out_manager  ! I/O manager
 
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcadv.F90	(revision 2643)
@@ -25,6 +25,4 @@
    USE traadv_eiv      ! eddy induced velocity     (tra_adv_eiv    routine)
    USE ldftra_oce      ! lateral diffusion coefficient on tracers
-   USE in_out_manager  ! I/O manager
-   USE lib_mpp         ! MPP library
    USE prtctl_trc      ! Print control
 
@@ -50,16 +48,12 @@
 CONTAINS
 
-   FUNCTION trc_adv_alloc()
+   INTEGER FUNCTION trc_adv_alloc()
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE trc_adv_alloc  ***
       !!----------------------------------------------------------------------
-      INTEGER :: trc_adv_alloc
-      !!----------------------------------------------------------------------
-
-      ALLOCATE(r2dt(jpk), Stat=trc_adv_alloc)
-
-      IF(trc_adv_alloc /= 0)THEN
-         CALL ctl_warn('trc_adv_alloc : failed to allocate array.')
-      END IF
+
+      ALLOCATE( r2dt(jpk), STAT=trc_adv_alloc )
+
+      IF( trc_adv_alloc /= 0 ) CALL ctl_warn('trc_adv_alloc : failed to allocate array.')
 
    END FUNCTION trc_adv_alloc
@@ -75,6 +69,6 @@
       !!----------------------------------------------------------------------
       USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
-      USE wrk_nemo, ONLY: zun => wrk_3d_1, zvn => wrk_3d_2, &
-                          zwn => wrk_3d_3   ! effective velocity
+      USE wrk_nemo, ONLY: zun => wrk_3d_4, zvn => wrk_3d_5, &
+                          zwn => wrk_3d_6   ! effective velocity
       !!
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
@@ -84,5 +78,5 @@
       !!----------------------------------------------------------------------
 
-      IF(wrk_in_use(3, 1,2,3))THEN
+      IF( wrk_in_use(3, 4,5,6) ) THEN
          CALL ctl_stop('trc_adv : requested workspace arrays unavailable.')
          RETURN
@@ -104,7 +98,7 @@
       DO jk = 1, jpkm1
          !                                                ! eulerian transport only
-         zun(:,:,jk) = e2u(:,:) * fse3u(:,:,jk) * un(:,:,jk)
-         zvn(:,:,jk) = e1v(:,:) * fse3v(:,:,jk) * vn(:,:,jk)
-         zwn(:,:,jk) = e1t(:,:) * e2t(:,:)      * wn(:,:,jk)
+         zun(:,:,jk) = e2u  (:,:) * fse3u(:,:,jk) * un(:,:,jk)
+         zvn(:,:,jk) = e1v  (:,:) * fse3v(:,:,jk) * vn(:,:,jk)
+         zwn(:,:,jk) = e1e2t(:,:)                 * wn(:,:,jk)
          !
       END DO
@@ -150,7 +144,5 @@
       END IF
       !
-      IF(wrk_not_released(3, 1,2,3))THEN
-         CALL ctl_stop('trc_adv : failed to release workspace arrays.')
-      END IF
+      IF( wrk_not_released(3, 4,5,6) ) CALL ctl_stop('trc_adv : failed to release workspace arrays.')
       !
    END SUBROUTINE trc_adv
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 2643)
@@ -27,7 +27,4 @@
    USE trdtra
    USE prtctl_trc      ! Print control
-   USE in_out_manager  ! I/O manager
-   USE lib_mpp         ! distribued memory computing library
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
 
    IMPLICIT NONE
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 2643)
@@ -57,8 +57,6 @@
       !!                   ***  ROUTINE trc_nxt_alloc  ***
       !!----------------------------------------------------------------------
-      USE lib_mpp, ONLY: ctl_warn
-      !!----------------------------------------------------------------------
       !
-      ALLOCATE( r2dt(jpk), Stat=trc_nxt_alloc)
+      ALLOCATE( r2dt(jpk), STAT=trc_nxt_alloc)
       !
       IF( trc_nxt_alloc /= 0 )   CALL ctl_warn('trc_nxt_alloc : failed to allocate array')
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcrad.F90	(revision 2643)
@@ -17,5 +17,4 @@
    USE trdmod_oce
    USE trdtra
-   USE lib_mpp
    USE prtctl_trc          ! Print control for debbuging
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 2643)
@@ -21,5 +21,4 @@
    USE trdmod_oce
    USE trdtra
-   USE lib_mpp         ! MPP library
 
    IMPLICIT NONE
@@ -59,5 +58,6 @@
       !!----------------------------------------------------------------------
       USE wrk_nemo, ONLY: wrk_in_use, wrk_not_released
-      USE wrk_nemo, zemps => wrk_2d_1
+      USE wrk_nemo, zemps  => wrk_2d_1
+      USE wrk_nemo, ztrtrd => wrk_3d_1
       !
       INTEGER, INTENT( in ) ::   kt          ! ocean time-step index
@@ -65,9 +65,8 @@
       INTEGER  ::   ji, jj, jn           ! dummy loop indices
       REAL(wp) ::   zsrau, zse3t   ! temporary scalars
-      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   ztrtrd
       CHARACTER (len=22) :: charout
       !!----------------------------------------------------------------------
 
-      IF(wrk_in_use(2, 1))THEN
+      IF( wrk_in_use(2, 1) .OR.  wrk_in_use(3, 1) ) THEN
          CALL ctl_stop('trc_sbc: requested workspace array unavailable.')   ;   RETURN
       END IF
@@ -79,6 +78,4 @@
       ENDIF
 
-
-      IF( l_trdtrc ) ALLOCATE( ztrtrd(jpi,jpj,jpk) )
 
       IF( lk_offline ) THEN          ! emps in dynamical files contains emps - rnf
@@ -115,6 +112,4 @@
       END DO                                                     ! tracer loop
       !                                                          ! ===========
-      IF( l_trdtrc ) DEALLOCATE( ztrtrd )
-
       IF( ln_ctl )   THEN
          WRITE(charout, FMT="('sbc ')") ;  CALL prt_ctl_trc_info(charout)
@@ -122,6 +117,7 @@
       ENDIF
 
-      IF( wrk_not_released(2, 1) )   CALL ctl_stop('trc_sbc: failed to release workspace array')
-      !
+      IF( wrk_not_released(2, 1) .OR. wrk_not_released(3, 1) )   &
+      &       CALL ctl_stop('trc_sbc: failed to release workspace array.')
+
    END SUBROUTINE trc_sbc
 
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 2643)
@@ -23,7 +23,4 @@
    USE trdtra
    USE prtctl_trc      ! Print control
-   USE in_out_manager  ! I/O manager
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE lib_mpp         ! MPP library
 
    IMPLICIT NONE
Index: /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90
===================================================================
--- /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 2642)
+++ /branches/dev_r2586_dynamic_mem/NEMOGCM/NEMO/TOP_SRC/TRP/trdmld_trc.F90	(revision 2643)
@@ -244,7 +244,6 @@
       !!----------------------------------------------------------------------
 
-      IF(wrk_in_use(2, 1))THEN
-         CALL ctl_stop('trd_mld_bio_zint : requested workspace array unavailable.')
-         RETURN
+      IF( wrk_in_use(2, 1) ) THEN
+         CALL ctl_stop('trd_mld_bio_zint : requested workspace array unavailable.') ; RETURN
       END IF
 
@@ -329,7 +328,5 @@
       END DO
 
-      IF(wrk_not_released(2, 1))THEN
-         CALL ctl_stop('trd_mld_bio_zint : failed to release workspace array.')
-      END IF
+      IF( wrk_not_released(2, 1) ) CALL ctl_stop('trd_mld_bio_zint : failed to release workspace array.')
 #endif
 
@@ -912,7 +909,6 @@
       IF( lrst_trc )   CALL trd_mld_trc_rst_write( kt )  ! this must be after the array swap above (III.3)
 
-      IF(wrk_not_released(3, 1,2,3,4,5,6,7,8,9))THEN
-         CALL ctl_stop('trd_mld_trc : failed to release workspace arrays.')
-      END IF
+      IF( wrk_not_released(3, 1,2,3,4,5,6,7,8,9) ) &
+      &   CALL ctl_stop('trd_mld_trc : failed to release workspace arrays.')
       !
    END SUBROUTINE trd_mld_trc
